/* 
 ***********************************************************
 $SNARK_Header$
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/trm6.h $
 $LastChangedRevision: 122 $
 $Date: 2014-07-09 18:18:59 -0400 (Wed, 09 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 Residual based stopping criterion

 */

#ifndef Termination_Criterion
#define Termination_Criterion

#include "termtest.h"
#include "blkdta.h"
#include "DistanceMeasure.h"

class TerminationCriterion: public termtest_class {

// attributes
private:
	REAL terminationValue; // the value at which the algorithm should get aborted
	DistanceMeasure* distanceMeasure; // the distance measure to use

	BOOLEAN reportingEnabled; // if reporting is enabled
	INTEGER reportingSkipFactor; // the skip factor
	CHAR* reportingFilename; // the filename to report

// methods
private:
	void reportCurrentValue(REAL currentDistance, INTEGER iteration);

protected:
	TerminationCriterion(DistanceMeasure* distanceMeasureIn,
			char* reportingFilenameIn);

public:
	virtual ~TerminationCriterion();

	void Init();

	BOOLEAN Run(REAL* recon, INTEGER* list, REAL* weight,
	INTEGER iter);
};

#endif
