/*
***********************************************************
$SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
$HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/art_artbck.cpp $
$LastChangedRevision: 85 $
$Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
$Author: agulati $
***********************************************************

 CALCULATE BACKPROJECTIONS (THE SAME AS BCKRAY)
 WITH OPTION "HALF" IN ART
*/

#include <cstdio>

#include "blkdta.h"
#include "modefl.h"

#include "art.h"
 
void art_class::artbck(
  REAL* pict,
  REAL amt,
  INTEGER* list,
  REAL* weight,
  INTEGER numb,
  REAL thrlo,
  REAL thrup,
  REAL relax,
  BOOLEAN bartf,
  REAL halfwy,
  REAL thtol,
  BOOLEAN art2f
)
{  
  INTEGER nb;
  INTEGER k;
  REAL pictk;

  if(numb == 0) return;

  for(nb = 0; nb < numb; nb++) {
    k = list[nb];
    pictk = pict[k];
    pictk += amt * weight[nb];


    if(!art2f) {
      pictk = clip(pictk, thrlo, thrup, relax);

      if(bartf) {

        if(Modefl.lofl && (pict[k] <= thrlo) && (pictk >= halfwy)) {
          pictk = halfwy - thtol;
        }

        if(Modefl.upfl && (pict[k] >= thrup) && (pictk <= halfwy)) {
          pictk = halfwy + thtol;
        }
      }
    }


    pict[k] = pictk;
  }
  return;
}      
