/* 
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/blob.h $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

#ifndef BLOB_H
#define BLOB_H

#include "blkdta.h"
#include "blob.h"

#define samp   100000

// common blob variables

extern class Blob_class
{
private:

	REAL radial(REAL dist);REAL lintegral(REAL dist);REAL dc();
	void p2b_neighb(INTEGER k, INTEGER j, REAL* pict, REAL *nc, REAL rneigh);
	void Correct(
	REAL* pict,
	REAL* blob_array,
	REAL* u,
	REAL* Delta,
	REAL* Gamma,
	INTEGER* que,
	INTEGER count,
	INTEGER* ncount,
	REAL* sd,
	REAL width,
	REAL frelax);

public:
	BOOLEAN pix_basis;   //true if pixel basis, false if blob basis
	REAL support;    // support of a blob
	REAL shape;    //  shape of a blob
	REAL delta;    // resolution of the (hexagonal) grid
	INTEGER area;     // M*H
	INTEGER diag; // number of diag containing blob centers in the underlying square grid (M+H)/2
	INTEGER M; // number of underlying square grid points in the horizontal direction
	INTEGER H; // number of underlying square grid points in the vertical direction
	REAL *recon;      // array of the blob coefficients
	REAL *vtable;    // values of the blob function at distances 1e-5*k*support
	REAL *ltable;   // values of the proj of a blob at distances 1e-5*k*support
	INTEGER lkf, lkl, ljf, ljl;INTEGER lmf, lml;INTEGER lhf, lhl;INTEGER M2, H2;INTEGER pr;REAL sampiblob; // samp/support
	REAL di2;        // delta/2
	REAL di2sq3;     // sqrt3*delta/2

	Blob_class();
	void setparam();
	void table();
	void blob2pix(REAL *blob_array, REAL *pict);
	void pix2blob(REAL* pict, REAL* blob_array);
	void footp(REAL* pict, REAL* blob_array, INTEGER option);
	void bpix(INTEGER nv, INTEGER nh, INTEGER *list, REAL* weight, INTEGER *numb, REAL *snorm);
	void bwray(INTEGER np,INTEGER nr, INTEGER* list, REAL* weight, INTEGER* numb, REAL* snorm);
	void bray(INTEGER np, INTEGER nr, INTEGER* list, REAL* weight, INTEGER* numb, REAL* snorm);
	REAL bpseudo(REAL* pict,INTEGER np,INTEGER nr,INTEGER* list,REAL* weight,INTEGER* numb,REAL* snorm,BOOLEAN line,BOOLEAN constr);
	void bbldlst(INTEGER** lbase, REAL** wbase);
	void bsmooth(REAL* a, INTEGER H, INTEGER M, REAL thresh, REAL w1, REAL w2);
} Blob;

#endif
