/*
***********************************************************
$SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
$HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/creatr.cpp $
$LastChangedRevision: 85 $
$Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
$Author: agulati $
***********************************************************
 */

// CREATR GENERATES FILE11 WITH THE FORMAT REQUIRED
// FOR INPUT BY THE 'PICTURE' AND 'PROJECTION' COMMANDS

#include <cstdlib>
#include <cstdio>

#include "blkdta.h"
#include "creacm.h"
#include "uiod.h"

#include "geom.h"
#include "creatr.h"
#include "creaer.h"
#include "creaph.h"
#include "creapr.h"
#include "second.h"

#include "file11.h"
#include "infile.h"

void creatr() {
    REAL time;
    REAL begin;
    REAL end;

    static BOOLEAN called = FALSE;

    //??  real aperwt

    // TEST FOR MULTIPLE CALLS FOR CREATR; CALLED = .TRUE. IF
    // CREATR HAS BEEN CALLED ONCE

    if (called) {
        creaer(1);
    }
    called = TRUE;


    // INPUT PHASE

    InFile.CreaInCrea();

    // IF ERFLAG IS SET TO .TRUE. THEN INPUT HAS ERRORS; ABORT JOB
    if (Creacm.erflag) {
        fprintf(output, "\n **** error in inputfile");
        fprintf(output, "\n **** program aborted\n");
        exit(-1);
    }

    // IF PHANTOM IS SPECIFIED, PICFLG = .TRUE. THEN START CREATING FILE1

    if (Creacm.picflg) {
        second(&begin);
        File11.wrhdr(CHAR2INT('p', 'h', 'a', 'n'));
        creaph( );
        second(&end);
        time = end - begin;


        fprintf(output, "\n         %10.3f seconds phantom creation", time); // changed precision to three digits - swr 1/21/06
    }

    // IF RAYSUMS ARE SPECIFIED, PRJFLG = .TRUE. , START CREATING FILE11

    if (Creacm.prjflg) {
        second(&begin);
        File11.wrhdr(CHAR2INT('r', 'a', 'y', 's'));
        File11.Flush();
        creapr( );
        File11.Flush();
        second(&end);
        time = end - begin;

        fprintf(output, "\n         %10.3f seconds projection data creation", time); // changed precision to two digits - swr 1/21/06
    }

}
