/*
**********************************************************************
$SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
$HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/disp.cpp $
$LastChangedRevision: 85 $
$Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
$Author: agulati $
**********************************************************************

 PRODUCE THE NUMERIC DISPLAY OF A RECONSTRUCTION ON THE PRINTER.
 CALLED BY DISP.
*/

#include <cstdio>

#include "blkdta.h"

#include "disp.h"

void disp(REAL* a, INTEGER nrow, INTEGER mcol, REAL scale, FILE* file)
{
    
  INTEGER nlim;
  INTEGER n;
  int m, i;
  INTEGER mfst;
  INTEGER mlst;
  INTEGER ifst;
  INTEGER ilst;


  fprintf(file, "\n                    scaling factor = %10.4f\n", scale);      
      
  nlim = nrow * mcol;
  for(n = 0; n < nlim; n++) {
  
    a[n] = scale * a[n]; 
  }

  for(mfst = 0; mfst < mcol; mfst+=10) { // bug 130 - fix loop increment - swr - 7/6/05
    mlst = MIN0(mfst + 9, mcol - 1);  // Bug 130 - fix the number of columns printed. Lajos, 7/8/05
    fprintf(file, "\n\n                    printing columns %4i to %4i", mfst, mlst);
    fprintf(file, "\n\n           ");
    for(m = mfst; m <= mlst; m++) {
      fprintf(file, " %10i", m);
    }

    ifst = mfst;
    ilst = mlst;
    for(n = 0; n <nrow; n++) {
      fprintf(file, "\n  %5d     ",n);
      for(i = ifst; i <= ilst; i++) {
        fprintf(file, " %10.4f", a[i]);
      }

      ifst += mcol;
      ilst += mcol;
    }
  }
  return;
}
