/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/foru_fft.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 FFT: FAST FOURIER TRANSFORM
 PURPOSE: PERFORM FOURIER TRANSFORM ON ARRAY X DIMENSIONED BY N
 INVDIR = 1 : FORWARD TRANSFORM
 -1: BACKTRANSFORM
 */

#include <cstdio>
#include <cmath>
#include "blkdta.h"
#include "rtfort.h"
#include "fourie.h"
#include "consts.h"
#include "uiod.h"

#include "foru.h"

void foru_class::fft(REAL* x, INTEGER* n, INTEGER invdir, REAL fact)
{
	INTEGER n2;
	INTEGER kh;
	INTEGER k;

	if (invdir != -1)
	{

		n2 = Fourie.nsize1 + 2;

		rtfort(x, n, invdir);

		kh = Fourie.nsize1 + 2;
		for (k = 0; k < kh; k++)
		{
			x[k] *= fact;
			if (fabs(x[k]) <= Consts.zero)
				x[k] = 0.0;
		}
		return;
	}

	rtfort(x, n, invdir);

	kh = Fourie.nsize2 * (Fourie.nsize2 + 2);

	for (k = 0; k < kh; k++)
	{
		x[k] *= fact;
	}
	return;
}
