/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/getint.cpp $
 $LastChangedRevision: 80 $
 $Date: 2014-07-01 21:01:54 -0400 (Tue, 01 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 GETINT SCANS THE INPUT AREA FOR THE NEXT NUMBER AND RETURNS
 THE INTERNAL INTEGER REPRESENTATION OF THE NUMBER.
 IF THE INPUT AREA DOES NOT CONTAIN A NUMBER, ZERO IS
 RETURNED AND EOL IS SET TO .TRUE.
 */

#include <cstdlib>
#include <cstdio>
#include <cctype>

#include "blkdta.h"
#include "uiod.h"

#include "chtoin.h"

#include "inputfile.h" 

INTEGER InputFile_class::getint(BOOLEAN NewLine, BOOLEAN* eol)
{

	INTEGER sign;
	CHAR nextch;
	INTEGER intvalue;
	//BOOLEAN flag;
	//bug 274 (there is no check for number of digits in the number,
	//this should be <=9, fixed by Joanna Klukowska
	INTEGER numOfDigits = 1; //bug 274, RD

	int i;

	*eol = FALSE;
	if (NewLine)
	{
		getnxt(FALSE);
	}

	intvalue = 0;

	// FIND START OF NUMBER (FIRST DIGIT) AND SIGN

	sign = 1;

	for (;;)
	{
		ptr++;
		if (ptr > DATASIZ)
		{ // NO NUMBER FOUND  // bug 190 - swr - 12/09/05
			*eol = TRUE;
			return 0;
		}
		nextch = data[ptr];
		if (isdigit(nextch))
			break;
		if (nextch == '-')
		{
			sign = -1;
		}
		else
		{
			sign = 1;
		}
	}

	// PROCESS INTEGER PART

	do
	{
		intvalue = 10 * intvalue + (chtoin(nextch));
		ptr++;
		nextch = data[ptr];
		numOfDigits++;   //bug 274, jklukowska
	} while (isdigit(nextch) && numOfDigits <= 9);  //bug 274, jklukowska

	if (nextch != ' ')
	{
		// ERROR - ILLEGAL REPRESENTATION OF NUMBER

		for (i = 0; i < DATASIZ; i++)
		{     // bug 190 - swr - 12/09/05
			data[i] = ' ';
		}

		data[ptr] = '*';
		fprintf(output,
				"\n **** illegal integer modifier encountered\n **** program aborted\n");
		exit(-1);
	}
	return sign * intvalue;
}
