/** @file display.cpp
    @package snark14Input
    @author Bruno M. Carvalho and Deniz Sarioz 
    modified by Joanna Klukowska (June 2008)
	added two fields in LAST line fore agreement with snark14
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

/****************************************************************************
** Form implementation generated from reading ui file 'display.ui'
**
** Created: Tue May 14 10:50:39 2002
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "display.h"
#include "misc.h"
#include "variables.h"

#include <qcheckbox.h>
#include <qframe.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qmessagebox.h>

/** 
 *  Constructs a displaywindow which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
displaywindow::displaywindow( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "displaywindow" );
    resize( 400, 350 ); 
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, sizePolicy().hasHeightForWidth() ) );
    setMinimumSize( QSize( 400, 350 ) );
    setMaximumSize( QSize( 400, 350 ) );
    setCaption( tr( "Display Window" ) );

    displaylabel = new QLabel( this, "displaylabel" );
    displaylabel->setGeometry( QRect( 10, 10, 100, 30 ) ); 
    displaylabel->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, displaylabel->sizePolicy().hasHeightForWidth() ) );
    displaylabel->setMinimumSize( QSize( 100, 30 ) );
    displaylabel->setMaximumSize( QSize( 100, 30 ) );
    displaylabel->setText( tr( "DISPLAY" ) );

    scalebox = new QCheckBox( this, "scalebox" );
    scalebox->setGeometry( QRect( 30, 60, 80, 30 ) ); 
    scalebox->setText( tr( "SCALE" ) );
    QObject::connect(scalebox,SIGNAL(clicked()),this,SLOT(activateScaleFields()));

    scale = new QLineEdit( this, "lowervalue" );
    scale->setGeometry( QRect( 150, 60, 50, 30 ) ); 
    scale->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, scale->sizePolicy().hasHeightForWidth() ) );
    scale->setEnabled(FALSE);

    scalelabel = new QLabel( this, "scalelabel" );
    scalelabel->setGeometry( QRect( 150, 40, 40, 20 ) ); 
    scalelabel->setText( tr( "scale" ) );
    scalelabel->setEnabled(FALSE);

    phantombox = new QCheckBox( this, "columnsbox" );
    phantombox->setGeometry( QRect( 30, 130, 110, 30 ) ); 
    phantombox->setText( tr( "PHANTOM" ) );

    iterationflagline = new QLineEdit( this, "iterationflagline" );
    iterationflagline->setGeometry( QRect( 50, 200, 310, 30 ) ); 
    iterationflagline->setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, iterationflagline->sizePolicy().hasHeightForWidth() ) );

    iterationflaglabel = new QLabel( this, "iterationflaglabel" );
    iterationflaglabel->setGeometry( QRect( 140, 180, 130, 20 ) ); 
    iterationflaglabel->setText( tr( "iteration_flag_line" ) );

    Line1 = new QFrame( this, "Line1" );
    Line1->setGeometry( QRect( 0, 275, 400, 16 ) ); 
    Line1->setFrameStyle( QFrame::HLine | QFrame::Sunken );

    okbutton = new QPushButton( this, "okbutton" );
    okbutton->setGeometry( QRect( 50, 290, 100, 40 ) ); 
    okbutton->setText( tr( "OK" ) );
    QObject::connect(okbutton,SIGNAL(clicked()),this,SLOT(checkValues()));

    cancelbutton = new QPushButton( this, "cancelbutton" );
    cancelbutton->setGeometry( QRect( 250, 290, 100, 40 ) ); 
    cancelbutton->setText( tr( "Cancel" ) );
    QObject::connect(cancelbutton,SIGNAL(clicked()),this,SLOT(reject()));
}

/**  
 *  Destroys the object and frees any allocated resources
 */
displaywindow::~displaywindow()
{
    // no need to delete child widgets, Qt does it all for us
}

/** Activates scale subfields 
@param void
@author Bruno M. Carvalho
@version 1.0 */
void displaywindow::activateScaleFields()
{
  if(scalebox->isChecked()) {
    scale->setEnabled(TRUE);
    scalelabel->setEnabled(TRUE);
  }
  else {
    scale->setEnabled(FALSE);
    scalelabel->setEnabled(FALSE);
  }
}

/** Returns a string for DISPLAY input sequence
@param void
@return display
@author Bruno M. Carvalho
@version 1.0 */
QString displaywindow::getOutput()
{
  QString output;

  output.sprintf("DISPLAY ");
  if(scalebox->isChecked()) {
    output.append("SCALE ");
    output+=scale->text();
    output.append(" ");
  }
  if(phantombox->isChecked()) {
    output.append("PHANTOM");
  }
  output.append("\n");
  output+=iterationflagline->text();
  return output;
}

void displaywindow::checkValues()
{
  int f=0;
  float s=0;
  
  if(scalebox->isChecked()) {
    s=strtof((const char *)scale->text().lower());
    if(errnum) 
      f=1;
    if(s<=0)
      f=2;
  }
  if(!isintspace(iterationflagline->text()))
    f=3;
  switch(f) {
  case 0: accept();
    break;
  case 1: QMessageBox::information(this,"SnarkInput","Error!\n"
                                   "Invalid scale format");
    break;
  case 2: QMessageBox::information(this,"SnarkInput","Error!\n"
                                   "scale should be positive");
    break;
  case 3: QMessageBox::information(this,"SnarkInput","Error!\n"
                                   "iteration_flag_line must contain\n"
                                   "only 0-9 and spaces and must\n"
                                   "be non-empty");
    break;
  }
}
