/** @file stop.h
    @package snark14Input
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef STOPWINDOW_H
#define STOPWINDOW_H

#include <qvariant.h>
#include <qdialog.h>
#include <qcheckbox.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QButtonGroup;
class QFrame;
class QLabel;
class QLineEdit;
class QComboBox;
class QPushButton;
class QRadioButton;

class stopwindow : public QDialog
{ 
    Q_OBJECT

public:
    stopwindow( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~stopwindow();
    QString getOutput();

    QLabel* stoplabel;
    QButtonGroup* stopbuttongroup;
    QRadioButton* iterationbutton;
    QRadioButton* terminationbutton;
    QRadioButton* nonebutton;
    QCheckBox* rprtcb;
    QLineEdit* iter;
    QLabel* iterlabel;
    QComboBox* testname;
    QLabel* testnamelabel;
    QLineEdit* epsilon;
    QLineEdit* skips;
    QLabel* skipslabel;
    QLabel* epsilonlabel;
    QFrame* Line17;
    QPushButton* okbutton;
    QPushButton* cancelbutton;
private slots:
      //void activateFields();
    void activateIterationFields();
    void activateTerminationFields();
    void deactivateFields();
    void checkValues();
    void setEpsilon();
    void setSkips();
};

#endif // STOPWINDOW_H
